/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AudioListenerBinding.h"
#include "WrapperFactory.h"
#include "mozilla/FloatingPoint.h"
#include "mozilla/dom/AudioListener.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {

namespace AudioListenerBinding {

static bool
get_dopplerFactor(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, JSJitGetterCallArgs args)
{
  double result(self->DopplerFactor());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static bool
set_dopplerFactor(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, JSJitSetterCallArgs args)
{
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Value being assigned to AudioListener.dopplerFactor");
    return false;
  }
  self->SetDopplerFactor(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo dopplerFactor_getterinfo = {
 { (JSJitGetterOp)get_dopplerFactor },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo dopplerFactor_setterinfo = {
 { (JSJitGetterOp)set_dopplerFactor },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_speedOfSound(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, JSJitGetterCallArgs args)
{
  double result(self->SpeedOfSound());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static bool
set_speedOfSound(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, JSJitSetterCallArgs args)
{
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Value being assigned to AudioListener.speedOfSound");
    return false;
  }
  self->SetSpeedOfSound(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo speedOfSound_getterinfo = {
 { (JSJitGetterOp)get_speedOfSound },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo speedOfSound_setterinfo = {
 { (JSJitGetterOp)set_speedOfSound },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
setPosition(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "AudioListener.setPosition");
  }
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of AudioListener.setPosition");
    return false;
  }
  double arg1;
  if (!ValueToPrimitive<double, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of AudioListener.setPosition");
    return false;
  }
  double arg2;
  if (!ValueToPrimitive<double, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of AudioListener.setPosition");
    return false;
  }
  self->SetPosition(arg0, arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo setPosition_methodinfo = {
 { (JSJitGetterOp)setPosition },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
setOrientation(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "AudioListener.setOrientation");
  }
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of AudioListener.setOrientation");
    return false;
  }
  double arg1;
  if (!ValueToPrimitive<double, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of AudioListener.setOrientation");
    return false;
  }
  double arg2;
  if (!ValueToPrimitive<double, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of AudioListener.setOrientation");
    return false;
  }
  double arg3;
  if (!ValueToPrimitive<double, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of AudioListener.setOrientation");
    return false;
  }
  double arg4;
  if (!ValueToPrimitive<double, eDefault>(cx, args[4], &arg4)) {
    return false;
  } else if (!mozilla::IsFinite(arg4)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 5 of AudioListener.setOrientation");
    return false;
  }
  double arg5;
  if (!ValueToPrimitive<double, eDefault>(cx, args[5], &arg5)) {
    return false;
  } else if (!mozilla::IsFinite(arg5)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 6 of AudioListener.setOrientation");
    return false;
  }
  self->SetOrientation(arg0, arg1, arg2, arg3, arg4, arg5);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo setOrientation_methodinfo = {
 { (JSJitGetterOp)setOrientation },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
setVelocity(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::AudioListener* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "AudioListener.setVelocity");
  }
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of AudioListener.setVelocity");
    return false;
  }
  double arg1;
  if (!ValueToPrimitive<double, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of AudioListener.setVelocity");
    return false;
  }
  double arg2;
  if (!ValueToPrimitive<double, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of AudioListener.setVelocity");
    return false;
  }
  self->SetVelocity(arg0, arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo setVelocity_methodinfo = {
 { (JSJitGetterOp)setVelocity },
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<JS::Value> vp)
{
  mozilla::dom::AudioListener* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::AudioListener>(obj);
  // We don't want to preserve if we don't have a wrapper.
  if (self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::AudioListener* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::AudioListener>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::AudioListener>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::AudioListener>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::AudioListener* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::AudioListener>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("setPosition", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&setPosition_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("setOrientation", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&setOrientation_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("setVelocity", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&setVelocity_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[4];

static const JSPropertySpec sAttributes_specs[] = {
  { "dopplerFactor", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &dopplerFactor_getterinfo } }, { { GenericBindingSetter, &dopplerFactor_setterinfo } }},
  { "speedOfSound", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &speedOfSound_getterinfo } }, { { GenericBindingSetter, &speedOfSound_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[3];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::AudioListener,
  constructors::id::AudioListener,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function AudioListener() {\n    [native code]\n}",
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "AudioListenerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object AudioListenerPrototype]",
  prototypes::id::AudioListener,
  PrototypeTraits<prototypes::id::AudioListener>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

static const DOMJSClass Class = {
  { "AudioListener",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::AudioListener, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::AudioListener >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::AudioListener>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::AudioListener>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::AudioListener* aObject, nsWrapperCache* aCache, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::AudioListener*>(aObject) ==
             reinterpret_cast<mozilla::dom::AudioListener*>(aObject));
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> proto = GetProtoObjectHandle(aCx, global);
  if (!proto) {
    return false;
  }

  BindingJSObjectCreator<mozilla::dom::AudioListener> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, global, aObject, aReflector);
  if (!aReflector) {
    return false;
  }


  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::AudioListener),
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::AudioListener),
                              &sNativeProperties,
                              nullptr,
                              "AudioListener", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::AudioListener)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::AudioListener).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::AudioListener)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::AudioListener).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace AudioListenerBinding



} // namespace dom
} // namespace mozilla
