/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AtomList.h"
#include "IdentityBinding.h"
#include "WrapperFactory.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "nsIGlobalObject.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


IdentityGetOptions::IdentityGetOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
IdentityGetOptions::InitIds(JSContext* cx, IdentityGetOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->tosURL_id.init(cx, "tosURL") ||
      !atomsCache->termsOfService_id.init(cx, "termsOfService") ||
      !atomsCache->siteName_id.init(cx, "siteName") ||
      !atomsCache->siteLogo_id.init(cx, "siteLogo") ||
      !atomsCache->privacyURL_id.init(cx, "privacyURL") ||
      !atomsCache->privacyPolicy_id.init(cx, "privacyPolicy")) {
    return false;
  }
  return true;
}

bool
IdentityGetOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  IdentityGetOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<IdentityGetOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->privacyPolicy_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mPrivacyPolicy.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mPrivacyPolicy.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->privacyURL_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mPrivacyURL.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mPrivacyURL.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->siteLogo_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mSiteLogo.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mSiteLogo.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->siteName_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mSiteName.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mSiteName.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->termsOfService_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTermsOfService.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mTermsOfService.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->tosURL_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTosURL.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mTosURL.Value()))) {
      return false;
    }
  }
  return true;
}

bool
IdentityGetOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
IdentityGetOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  IdentityGetOptionsAtoms* atomsCache = GetAtomCache<IdentityGetOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mPrivacyPolicy.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mPrivacyPolicy.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->privacyPolicy_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mPrivacyURL.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mPrivacyURL.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->privacyURL_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mSiteLogo.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mSiteLogo.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->siteLogo_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mSiteName.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mSiteName.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->siteName_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTermsOfService.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mTermsOfService.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->termsOfService_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTosURL.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mTosURL.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->tosURL_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
IdentityGetOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
IdentityGetOptions::TraceDictionary(JSTracer* trc)
{
}

void
IdentityGetOptions::operator=(const IdentityGetOptions& aOther)
{
  if (aOther.mPrivacyPolicy.WasPassed()) {
    mPrivacyPolicy.Construct();
    mPrivacyPolicy.Value() = aOther.mPrivacyPolicy.Value();
  } else {
    mPrivacyPolicy.Reset();
  }
  if (aOther.mPrivacyURL.WasPassed()) {
    mPrivacyURL.Construct();
    mPrivacyURL.Value() = aOther.mPrivacyURL.Value();
  } else {
    mPrivacyURL.Reset();
  }
  if (aOther.mSiteLogo.WasPassed()) {
    mSiteLogo.Construct();
    mSiteLogo.Value() = aOther.mSiteLogo.Value();
  } else {
    mSiteLogo.Reset();
  }
  if (aOther.mSiteName.WasPassed()) {
    mSiteName.Construct();
    mSiteName.Value() = aOther.mSiteName.Value();
  } else {
    mSiteName.Reset();
  }
  if (aOther.mTermsOfService.WasPassed()) {
    mTermsOfService.Construct();
    mTermsOfService.Value() = aOther.mTermsOfService.Value();
  } else {
    mTermsOfService.Reset();
  }
  if (aOther.mTosURL.WasPassed()) {
    mTosURL.Construct();
    mTosURL.Value() = aOther.mTosURL.Value();
  } else {
    mTosURL.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



IdentityRequestOptions::IdentityRequestOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
IdentityRequestOptions::InitIds(JSContext* cx, IdentityRequestOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->termsOfService_id.init(cx, "termsOfService") ||
      !atomsCache->siteName_id.init(cx, "siteName") ||
      !atomsCache->siteLogo_id.init(cx, "siteLogo") ||
      !atomsCache->returnTo_id.init(cx, "returnTo") ||
      !atomsCache->refreshAuthentication_id.init(cx, "refreshAuthentication") ||
      !atomsCache->privacyPolicy_id.init(cx, "privacyPolicy") ||
      !atomsCache->origin_id.init(cx, "origin") ||
      !atomsCache->oncancel_id.init(cx, "oncancel") ||
      !atomsCache->backgroundColor_id.init(cx, "backgroundColor")) {
    return false;
  }
  return true;
}

bool
IdentityRequestOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  IdentityRequestOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<IdentityRequestOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->backgroundColor_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mBackgroundColor.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mBackgroundColor.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->oncancel_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOncancel.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
        { // Scope for tempRoot
          JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
          (mOncancel.Value()) = new IdentityOnCancelCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
        }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'oncancel' member of IdentityRequestOptions");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'oncancel' member of IdentityRequestOptions");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->origin_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOrigin.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mOrigin.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->privacyPolicy_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mPrivacyPolicy.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mPrivacyPolicy.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->refreshAuthentication_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mRefreshAuthentication.Construct();
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &(mRefreshAuthentication.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->returnTo_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mReturnTo.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mReturnTo.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->siteLogo_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mSiteLogo.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mSiteLogo.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->siteName_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mSiteName.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mSiteName.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->termsOfService_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTermsOfService.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mTermsOfService.Value()))) {
      return false;
    }
  }
  return true;
}

bool
IdentityRequestOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
IdentityRequestOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  IdentityRequestOptionsAtoms* atomsCache = GetAtomCache<IdentityRequestOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mBackgroundColor.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mBackgroundColor.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->backgroundColor_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOncancel.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      OwningNonNull<IdentityOnCancelCallback> const & currentValue = mOncancel.InternalValue();
      temp.setObject(*GetCallbackFromCallbackObject(currentValue));
      if (!MaybeWrapObjectValue(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->oncancel_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOrigin.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mOrigin.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->origin_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mPrivacyPolicy.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mPrivacyPolicy.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->privacyPolicy_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mRefreshAuthentication.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      int32_t const & currentValue = mRefreshAuthentication.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->refreshAuthentication_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mReturnTo.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mReturnTo.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->returnTo_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mSiteLogo.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mSiteLogo.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->siteLogo_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mSiteName.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mSiteName.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->siteName_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTermsOfService.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mTermsOfService.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->termsOfService_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
IdentityRequestOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
IdentityRequestOptions::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail



IdentityWatchOptions::IdentityWatchOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
IdentityWatchOptions::InitIds(JSContext* cx, IdentityWatchOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->wantIssuer_id.init(cx, "wantIssuer") ||
      !atomsCache->onready_id.init(cx, "onready") ||
      !atomsCache->onlogout_id.init(cx, "onlogout") ||
      !atomsCache->onlogin_id.init(cx, "onlogin") ||
      !atomsCache->onerror_id.init(cx, "onerror") ||
      !atomsCache->loggedInUser_id.init(cx, "loggedInUser") ||
      !atomsCache->audience_id.init(cx, "audience")) {
    return false;
  }
  return true;
}

bool
IdentityWatchOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  IdentityWatchOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<IdentityWatchOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->audience_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mAudience.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mAudience.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->loggedInUser_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mLoggedInUser.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mLoggedInUser.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->onerror_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOnerror.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
        { // Scope for tempRoot
          JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
          (mOnerror.Value()) = new IdentityOnErrorCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
        }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'onerror' member of IdentityWatchOptions");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'onerror' member of IdentityWatchOptions");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->onlogin_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOnlogin.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
        { // Scope for tempRoot
          JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
          (mOnlogin.Value()) = new IdentityOnLoginCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
        }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'onlogin' member of IdentityWatchOptions");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'onlogin' member of IdentityWatchOptions");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->onlogout_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOnlogout.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
        { // Scope for tempRoot
          JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
          (mOnlogout.Value()) = new IdentityOnLogoutCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
        }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'onlogout' member of IdentityWatchOptions");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'onlogout' member of IdentityWatchOptions");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->onready_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOnready.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
        { // Scope for tempRoot
          JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
          (mOnready.Value()) = new IdentityOnReadyCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
        }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'onready' member of IdentityWatchOptions");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'onready' member of IdentityWatchOptions");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->wantIssuer_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mWantIssuer.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mWantIssuer.Value()))) {
      return false;
    }
  }
  return true;
}

bool
IdentityWatchOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
IdentityWatchOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  IdentityWatchOptionsAtoms* atomsCache = GetAtomCache<IdentityWatchOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mAudience.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mAudience.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->audience_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mLoggedInUser.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mLoggedInUser.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->loggedInUser_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOnerror.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      OwningNonNull<IdentityOnErrorCallback> const & currentValue = mOnerror.InternalValue();
      temp.setObject(*GetCallbackFromCallbackObject(currentValue));
      if (!MaybeWrapObjectValue(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->onerror_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOnlogin.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      OwningNonNull<IdentityOnLoginCallback> const & currentValue = mOnlogin.InternalValue();
      temp.setObject(*GetCallbackFromCallbackObject(currentValue));
      if (!MaybeWrapObjectValue(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->onlogin_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOnlogout.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      OwningNonNull<IdentityOnLogoutCallback> const & currentValue = mOnlogout.InternalValue();
      temp.setObject(*GetCallbackFromCallbackObject(currentValue));
      if (!MaybeWrapObjectValue(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->onlogout_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mOnready.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      OwningNonNull<IdentityOnReadyCallback> const & currentValue = mOnready.InternalValue();
      temp.setObject(*GetCallbackFromCallbackObject(currentValue));
      if (!MaybeWrapObjectValue(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->onready_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mWantIssuer.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mWantIssuer.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->wantIssuer_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
IdentityWatchOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
IdentityWatchOptions::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail


void
IdentityOnReadyCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



void
IdentityOnLoginCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& identityAssertion, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    nsString mutableStr(identityAssertion);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



void
IdentityOnLogoutCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



void
IdentityOnCancelCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& error, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    nsString mutableStr(error);
    if (!xpc::StringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



void
IdentityOnErrorCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& error, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    nsString mutableStr(error);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



namespace IdentityManagerBinding {

static bool
watch(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IdentityManager* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  binding_detail::FastIdentityWatchOptions arg0;
  if (!arg0.Init(cx, (args.hasDefined(0)) ? args[0] : JS::NullHandleValue, "Argument 1 of IdentityManager.watch", true)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->Watch(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "IdentityManager", "watch", true);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo watch_methodinfo = {
 { (JSJitGetterOp)watch },
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
request(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IdentityManager* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  binding_detail::FastIdentityRequestOptions arg0;
  if (!arg0.Init(cx, (args.hasDefined(0)) ? args[0] : JS::NullHandleValue, "Argument 1 of IdentityManager.request", true)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->Request(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "IdentityManager", "request", true);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo request_methodinfo = {
 { (JSJitGetterOp)request },
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
logout(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IdentityManager* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->Logout(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "IdentityManager", "logout", true);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo logout_methodinfo = {
 { (JSJitGetterOp)logout },
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IdentityManager* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "IdentityManager.get");
  }
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  OwningNonNull<IdentityOnLoginCallback> arg0;
  if (args[0].isObject()) {
    if (JS::IsCallable(&args[0].toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new IdentityOnLoginCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Argument 1 of IdentityManager.get");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of IdentityManager.get");
    return false;
  }
  binding_detail::FastIdentityGetOptions arg1;
  if (!arg1.Init(cx, (args.hasDefined(1)) ? args[1] : JS::NullHandleValue, "Argument 2 of IdentityManager.get", true)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->Get(NonNullHelper(arg0), Constify(arg1), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "IdentityManager", "get", true);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo get_methodinfo = {
 { (JSJitGetterOp)get },
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
getVerifiedEmail(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IdentityManager* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "IdentityManager.getVerifiedEmail");
  }
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  OwningNonNull<IdentityOnLoginCallback> arg0;
  if (args[0].isObject()) {
    if (JS::IsCallable(&args[0].toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new IdentityOnLoginCallback(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Argument 1 of IdentityManager.getVerifiedEmail");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of IdentityManager.getVerifiedEmail");
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->GetVerifiedEmail(NonNullHelper(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "IdentityManager", "getVerifiedEmail", true);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo getVerifiedEmail_methodinfo = {
 { (JSJitGetterOp)getVerifiedEmail },
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static already_AddRefed<IdentityManager>
ConstructNavigatorObjectHelper(JSContext* cx, GlobalObject& global, ErrorResult& aRv)
{
  JS::Rooted<JSObject*> jsImplObj(cx);
  nsCOMPtr<nsIGlobalObject> globalHolder =
    ConstructJSImplementation(cx, "@mozilla.org/identity/manager;1", global, &jsImplObj, aRv);
  if (aRv.Failed()) {
    return nullptr;
  }
  // Build the C++ implementation.
  nsRefPtr<IdentityManager> impl = new IdentityManager(jsImplObj, globalHolder);
  return impl.forget();
}

JSObject*
ConstructNavigatorObject(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  GlobalObject global(aCx, aObj);
  if (global.Failed()) {
    return nullptr;
  }
  ErrorResult rv;
  JS::Rooted<JS::Value> v(aCx);
  {  // Scope to make sure |result| goes out of scope while |v| is rooted
    nsRefPtr<mozilla::dom::IdentityManager> result = ConstructNavigatorObjectHelper(aCx, global, rv);
    rv.WouldReportJSException();
    if (rv.Failed()) {
      ThrowMethodFailedWithDetails(aCx, rv, "IdentityManager", "navigatorConstructor");
      return nullptr;
    }
    if (!GetOrCreateDOMReflector(aCx, result, &v)) {
      //XXX Assertion disabled for now, see bug 991271.
      MOZ_ASSERT(true || JS_IsExceptionPending(aCx));
      return nullptr;
    }
  }
  return &v.toObject();
}

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<JS::Value> vp)
{
  mozilla::dom::IdentityManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IdentityManager>(obj);
  // We don't want to preserve if we don't have a wrapper.
  if (self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::IdentityManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IdentityManager>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::IdentityManager>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::IdentityManager>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::IdentityManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IdentityManager>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("watch", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&watch_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("request", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&request_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("logout", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&logout_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END,
  JS_FNSPEC("get", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&get_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END,
  JS_FNSPEC("getVerifiedEmail", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getVerifiedEmail_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { true, nullptr, nullptr, nullptr, &sMethods_specs[4] },
  { true, nullptr, nullptr, nullptr, &sMethods_specs[6] },
  { false, nullptr }
};

static jsid sMethods_ids[8];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::IdentityManager,
  constructors::id::_ID_Count,
  nullptr
} };

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "IdentityManagerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object IdentityManagerPrototype]",
  prototypes::id::IdentityManager,
  PrototypeTraits<prototypes::id::IdentityManager>::Depth,
  JS_GetObjectPrototype
};

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.identity.enabled");
}

static const DOMJSClass Class = {
  { "IdentityManager",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::IdentityManager, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::IdentityManager >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::IdentityManager>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::IdentityManager>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::IdentityManager* aObject, nsWrapperCache* aCache, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::IdentityManager*>(aObject) ==
             reinterpret_cast<mozilla::dom::IdentityManager*>(aObject));
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> proto = GetProtoObjectHandle(aCx, global);
  if (!proto) {
    return false;
  }

  BindingJSObjectCreator<mozilla::dom::IdentityManager> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, global, aObject, aReflector);
  if (!aReflector) {
    return false;
  }


  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    sIdsInited = true;
  }

  static bool sPrefCachesInited = false;
  if (!sPrefCachesInited) {
    sPrefCachesInited = true;
    Preferences::AddBoolVarCache(&sMethods[1].enabled, "dom.identity.exposeLegacyGetAPI");
    Preferences::AddBoolVarCache(&sMethods[2].enabled, "dom.identity.exposeLegacyGetVerifiedEmailAPI");
  }

  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::IdentityManager),
                              constructorProto, nullptr, nullptr, 0, nullptr,
                              nullptr,
                              &sNativeProperties,
                              nullptr,
                              nullptr, aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::IdentityManager)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::IdentityManager).address());
}

} // namespace IdentityManagerBinding



void
IdentityManagerJSImpl::Watch(const IdentityWatchOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    if (!options.ToObjectInternal(cx, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  IdentityManagerAtoms* atomsCache = GetAtomCache<IdentityManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->watch_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
IdentityManagerJSImpl::Request(const IdentityRequestOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    if (!options.ToObjectInternal(cx, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  IdentityManagerAtoms* atomsCache = GetAtomCache<IdentityManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->request_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
IdentityManagerJSImpl::Logout(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  IdentityManagerAtoms* atomsCache = GetAtomCache<IdentityManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->logout_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
IdentityManagerJSImpl::Get(IdentityOnLoginCallback& callback, const IdentityGetOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(2)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 2;

  do {
    if (!options.ToObjectInternal(cx, argv[1])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  do {
    argv[0].setObject(*GetCallbackFromCallbackObject(callback));
    if (!MaybeWrapObjectValue(cx, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  IdentityManagerAtoms* atomsCache = GetAtomCache<IdentityManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->get_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
IdentityManagerJSImpl::GetVerifiedEmail(IdentityOnLoginCallback& callback, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    argv[0].setObject(*GetCallbackFromCallbackObject(callback));
    if (!MaybeWrapObjectValue(cx, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  IdentityManagerAtoms* atomsCache = GetAtomCache<IdentityManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->getVerifiedEmail_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

bool
IdentityManagerJSImpl::InitIds(JSContext* cx, IdentityManagerAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->getVerifiedEmail_id.init(cx, "getVerifiedEmail") ||
      !atomsCache->get_id.init(cx, "get") ||
      !atomsCache->logout_id.init(cx, "logout") ||
      !atomsCache->request_id.init(cx, "request") ||
      !atomsCache->watch_id.init(cx, "watch")) {
    return false;
  }
  return true;
}



NS_IMPL_CYCLE_COLLECTION_CLASS(IdentityManager)
NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN(IdentityManager)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mImpl)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mParent)
  NS_IMPL_CYCLE_COLLECTION_UNLINK_PRESERVED_WRAPPER
  tmp->ClearWeakReferences();
NS_IMPL_CYCLE_COLLECTION_UNLINK_END
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN(IdentityManager)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mImpl)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mParent)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE_SCRIPT_OBJECTS
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END
NS_IMPL_CYCLE_COLLECTION_TRACE_WRAPPERCACHE(IdentityManager)
NS_IMPL_CYCLE_COLLECTING_ADDREF(IdentityManager)
NS_IMPL_CYCLE_COLLECTING_RELEASE(IdentityManager)
NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(IdentityManager)
  NS_WRAPPERCACHE_INTERFACE_MAP_ENTRY
  NS_INTERFACE_MAP_ENTRY(nsISupports)
  NS_INTERFACE_MAP_ENTRY(nsISupportsWeakReference)
NS_INTERFACE_MAP_END

IdentityManager::IdentityManager(JS::Handle<JSObject*> aJSImplObject, nsIGlobalObject* aParent)
  : mImpl(new IdentityManagerJSImpl(aJSImplObject, /* aIncumbentGlobal = */ nullptr)),
    mParent(aParent)
{
}


IdentityManager::~IdentityManager()
{
}

nsISupports*
IdentityManager::GetParentObject() const
{
  return mParent;
}

JSObject*
IdentityManager::WrapObject(JSContext* aCx)
{
  JS::Rooted<JSObject*> obj(aCx, IdentityManagerBinding::Wrap(aCx, this));
  if (!obj) {
    return nullptr;
  }

  // Now define it on our chrome object
  JSAutoCompartment ac(aCx, mImpl->Callback());
  if (!JS_WrapObject(aCx, &obj)) {
    return nullptr;
  }
  if (!JS_DefineProperty(aCx, mImpl->Callback(), "__DOM_IMPL__", obj, 0)) {
    return nullptr;
  }
  return obj;
}

void
IdentityManager::Watch(const IdentityWatchOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->Watch(options, aRv, aCompartment);
}

void
IdentityManager::Request(const IdentityRequestOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->Request(options, aRv, aCompartment);
}

void
IdentityManager::Logout(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->Logout(aRv, aCompartment);
}

void
IdentityManager::Get(IdentityOnLoginCallback& callback, const IdentityGetOptions& options, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->Get(callback, options, aRv, aCompartment);
}

void
IdentityManager::GetVerifiedEmail(IdentityOnLoginCallback& callback, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->GetVerifiedEmail(callback, aRv, aCompartment);
}

bool
IdentityManager::_Create(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  if (args.length() < 2) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "IdentityManager._create");
  }
  if (!args[0].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of IdentityManager._create");
  }
  if (!args[1].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of IdentityManager._create");
  }

  // GlobalObject will go through wrappers as needed for us, and
  // is simpler than the right UnwrapArg incantation.
  GlobalObject global(cx, &args[0].toObject());
  if (global.Failed()) {
    return false;
  }
  nsCOMPtr<nsIGlobalObject> globalHolder = do_QueryInterface(global.GetAsSupports());
  MOZ_ASSERT(globalHolder);
  JS::Rooted<JSObject*> arg(cx, &args[1].toObject());
  nsRefPtr<IdentityManager> impl = new IdentityManager(arg, globalHolder);
  MOZ_ASSERT(js::IsObjectInContextCompartment(arg, cx));
  return GetOrCreateDOMReflector(cx, impl, args.rval());
}


} // namespace dom
} // namespace mozilla
