//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDocAccessibleParent_h
#define PDocAccessibleParent_h

#include "mozilla/a11y/PDocAccessible.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace a11y {


class /*NS_ABSTRACT_CLASS*/ PDocAccessibleParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::a11y::AccessibleData AccessibleData;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::a11y::Attribute Attribute;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::a11y::RelationTargets RelationTargets;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::a11y::ShowEventData ShowEventData;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PDocAccessible::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvEvent(
            const uint64_t& aID,
            const uint32_t& type) = 0;
    virtual bool
    RecvShowEvent(const ShowEventData& data) = 0;
    virtual bool
    RecvHideEvent(const uint64_t& aRootID) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PDocAccessibleParent();

    virtual ~PDocAccessibleParent();

    PContentParent*
    Manager() const;

    PDocAccessible::State
    state();

    bool
    SendState(
            const uint64_t& aID,
            uint64_t* states) NS_WARN_UNUSED_RESULT;

    bool
    SendName(
            const uint64_t& aID,
            nsString* name) NS_WARN_UNUSED_RESULT;

    bool
    SendValue(
            const uint64_t& aID,
            nsString* value) NS_WARN_UNUSED_RESULT;

    bool
    SendDescription(
            const uint64_t& aID,
            nsString* desc) NS_WARN_UNUSED_RESULT;

    bool
    SendAttributes(
            const uint64_t& aID,
            nsTArray<Attribute>* attributes) NS_WARN_UNUSED_RESULT;

    bool
    SendRelationByType(
            const uint64_t& aID,
            const uint32_t& aRelationType,
            nsTArray<uint64_t>* targets) NS_WARN_UNUSED_RESULT;

    bool
    SendRelations(
            const uint64_t& aID,
            nsTArray<RelationTargets>* relations) NS_WARN_UNUSED_RESULT;

    bool
    SendTextSubstring(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            nsString* aText) NS_WARN_UNUSED_RESULT;

    bool
    SendGetTextAfterOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset) NS_WARN_UNUSED_RESULT;

    bool
    SendGetTextAtOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset) NS_WARN_UNUSED_RESULT;

    bool
    SendGetTextBeforeOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset) NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PDocAccessibleParent* v__,
            Message* msg__,
            bool nullable__);

    bool
    Read(
            PDocAccessibleParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<AccessibleData>& v__,
            Message* msg__);

    bool
    Read(
            nsTArray<AccessibleData>* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<RelationTargets>& v__,
            Message* msg__);

    bool
    Read(
            nsTArray<RelationTargets>* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RelationTargets& v__,
            Message* msg__);

    bool
    Read(
            RelationTargets* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const ShowEventData& v__,
            Message* msg__);

    bool
    Read(
            ShowEventData* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<Attribute>& v__,
            Message* msg__);

    bool
    Read(
            nsTArray<Attribute>* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const AccessibleData& v__,
            Message* msg__);

    bool
    Read(
            AccessibleData* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const Attribute& v__,
            Message* msg__);

    bool
    Read(
            Attribute* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace a11y
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace a11y {
class DocAccessibleParent :
    public PDocAccessibleParent
{
    virtual bool
    RecvEvent(
            const uint64_t& aID,
            const uint32_t& type);

    virtual bool
    RecvShowEvent(const ShowEventData& data);

    virtual bool
    RecvHideEvent(const uint64_t& aRootID);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT DocAccessibleParent();
    virtual ~DocAccessibleParent();
};
} // namespace a11y
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace a11y {
bool
DocAccessibleParent::RecvEvent(
        const uint64_t& aID,
        const uint32_t& type)
{
    return false;
}

bool
DocAccessibleParent::RecvShowEvent(const ShowEventData& data)
{
    return false;
}

bool
DocAccessibleParent::RecvHideEvent(const uint64_t& aRootID)
{
    return false;
}

void
DocAccessibleParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT DocAccessibleParent::DocAccessibleParent()
{
    MOZ_COUNT_CTOR(DocAccessibleParent);
}

MOZ_IMPLICIT DocAccessibleParent::~DocAccessibleParent()
{
    MOZ_COUNT_DTOR(DocAccessibleParent);
}

} // namespace a11y
} // namespace mozilla
#endif // if 0

#endif // ifndef PDocAccessibleParent_h
