//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPrintingParent_h
#define PPrintingParent_h

#include "mozilla/embedding/PPrinting.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintProgressDialogParent;
} // namespace embedding
} // namespace mozilla
namespace mozilla {
namespace embedding {
class PPrintProgressDialogChild;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintProgressDialogParent;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace embedding {


class /*NS_ABSTRACT_CLASS*/ PPrintingParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

    friend class mozilla::embedding::PPrintProgressDialogParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::embedding::PrintData PrintData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::embedding::PPrintProgressDialogParent PPrintProgressDialogParent;
    typedef mozilla::embedding::PPrintProgressDialogChild PPrintProgressDialogChild;

    typedef PPrinting::State State;

    virtual bool
    RecvShowProgress(
            PBrowserParent* browser,
            PPrintProgressDialogParent* printProgressDialog,
            const bool& isForPrinting,
            bool* notifyOnOpen,
            bool* success) = 0;
    virtual bool
    RecvShowPrintDialog(
            PBrowserParent* browser,
            const PrintData& settings,
            PrintData* modifiedSettings,
            bool* success) = 0;
    virtual bool
    RecvPPrintProgressDialogConstructor(PPrintProgressDialogParent* actor);
    virtual PPrintProgressDialogParent*
    AllocPPrintProgressDialogParent() = 0;
    virtual bool
    DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PPrintingParent();

    virtual ~PPrintingParent();

    PContentParent*
    Manager() const;

    void
    ManagedPPrintProgressDialogParent(nsTArray<PPrintProgressDialogParent*>& aArr) const;
    const nsTArray<PPrintProgressDialogParent*>&
    ManagedPPrintProgressDialogParent() const;

    PPrinting::State
    state();

    static bool
    Send__delete__(PPrintingParent* actor) NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PPrintingParent* v__,
            Message* msg__,
            bool nullable__);

    bool
    Read(
            PPrintingParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const PrintData& v__,
            Message* msg__);

    bool
    Read(
            PrintData* v__,
            const Message* msg__,
            void** iter__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PBrowserParent* v__,
            Message* msg__,
            bool nullable__);

    bool
    Read(
            PBrowserParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PPrintProgressDialogParent* v__,
            Message* msg__,
            bool nullable__);

    bool
    Read(
            PPrintProgressDialogParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
    // Sorted by pointer value
    nsTArray<PPrintProgressDialogParent*> mManagedPPrintProgressDialogParent;
};


} // namespace embedding
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace embedding {
class PrintingParent :
    public PPrintingParent
{
    virtual bool
    RecvShowProgress(
            PBrowserParent* browser,
            PPrintProgressDialogParent* printProgressDialog,
            const bool& isForPrinting,
            bool* notifyOnOpen,
            bool* success);

    virtual bool
    RecvShowPrintDialog(
            PBrowserParent* browser,
            const PrintData& settings,
            PrintData* modifiedSettings,
            bool* success);

    virtual PPrintProgressDialogParent*
    AllocPPrintProgressDialogParent();

    virtual bool
    DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT PrintingParent();
    virtual ~PrintingParent();
};
} // namespace embedding
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace embedding {
bool
PrintingParent::RecvShowProgress(
        PBrowserParent* browser,
        PPrintProgressDialogParent* printProgressDialog,
        const bool& isForPrinting,
        bool* notifyOnOpen,
        bool* success)
{
    return false;
}

bool
PrintingParent::RecvShowPrintDialog(
        PBrowserParent* browser,
        const PrintData& settings,
        PrintData* modifiedSettings,
        bool* success)
{
    return false;
}

PPrintProgressDialogParent*
PrintingParent::AllocPPrintProgressDialogParent()
{
    return 0;
}

bool
PrintingParent::DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor)
{
    return false;
}

void
PrintingParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PrintingParent::PrintingParent()
{
    MOZ_COUNT_CTOR(PrintingParent);
}

MOZ_IMPLICIT PrintingParent::~PrintingParent()
{
    MOZ_COUNT_DTOR(PrintingParent);
}

} // namespace embedding
} // namespace mozilla
#endif // if 0

#endif // ifndef PPrintingParent_h
