//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundSharedTypes_h
#define PBackgroundSharedTypes_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ContentPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class ContentPrincipalInfo final
{
private:

public:
    MOZ_IMPLICIT ContentPrincipalInfo();

    MOZ_IMPLICIT ContentPrincipalInfo(
            const uint32_t& _appId,
            const bool& _isInBrowserElement,
            const nsCString& _spec)
    {
        Init();
        Assign(_appId, _isInBrowserElement, _spec);
    }

    MOZ_IMPLICIT ContentPrincipalInfo(const ContentPrincipalInfo& _o)
    {
        Init();
        Assign((_o).appId(), (_o).isInBrowserElement(), (_o).spec());
    }

    ~ContentPrincipalInfo();

    void
    operator=(const ContentPrincipalInfo& _o)
    {
        Assign((_o).appId(), (_o).isInBrowserElement(), (_o).spec());
    }

    bool
    operator==(const ContentPrincipalInfo& _o) const;

    uint32_t&
    appId()
    {
        return appId_;
    }
    const uint32_t&
    appId() const
    {
        return appId_;
    }

    bool&
    isInBrowserElement()
    {
        return isInBrowserElement_;
    }
    const bool&
    isInBrowserElement() const
    {
        return isInBrowserElement_;
    }

    nsCString&
    spec()
    {
        return spec_;
    }
    const nsCString&
    spec() const
    {
        return spec_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _appId,
            const bool& _isInBrowserElement,
            const nsCString& _spec);

    uint32_t appId_;
    bool isInBrowserElement_;
    nsCString spec_;
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SystemPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class SystemPrincipalInfo final
{
private:

public:
    MOZ_IMPLICIT SystemPrincipalInfo()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT SystemPrincipalInfo(const SystemPrincipalInfo& _o)
    {
        Init();
        Assign();
    }

    ~SystemPrincipalInfo();

    void
    operator=(const SystemPrincipalInfo& _o)
    {
        Assign();
    }

    bool
    operator==(const SystemPrincipalInfo& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NullPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class NullPrincipalInfo final
{
private:

public:
    MOZ_IMPLICIT NullPrincipalInfo()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT NullPrincipalInfo(const NullPrincipalInfo& _o)
    {
        Init();
        Assign();
    }

    ~NullPrincipalInfo();

    void
    operator=(const NullPrincipalInfo& _o)
    {
        Assign();
    }

    bool
    operator==(const NullPrincipalInfo& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class ContentPrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class SystemPrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class NullPrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union PrincipalInfo|
//
namespace mozilla {
namespace ipc {
class PrincipalInfo final
{
public:
    enum Type {
        T__None,
        TContentPrincipalInfo = 1,
        TSystemPrincipalInfo,
        TNullPrincipalInfo,
        T__Last = TNullPrincipalInfo
    };

private:
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef ContentPrincipalInfo ContentPrincipalInfo__tdef;
    typedef SystemPrincipalInfo SystemPrincipalInfo__tdef;
    typedef NullPrincipalInfo NullPrincipalInfo__tdef;

    union Value {
        char VContentPrincipalInfo[sizeof(ContentPrincipalInfo)];
        char VSystemPrincipalInfo[sizeof(SystemPrincipalInfo)];
        char VNullPrincipalInfo[sizeof(NullPrincipalInfo)];
    };

    ContentPrincipalInfo*
    ptr_ContentPrincipalInfo()
    {
        return reinterpret_cast<ContentPrincipalInfo*>((&((mValue).VContentPrincipalInfo)));
    }
    const ContentPrincipalInfo* const
    constptr_ContentPrincipalInfo() const
    {
        return reinterpret_cast<const ContentPrincipalInfo* const>((&((mValue).VContentPrincipalInfo)));
    }
    SystemPrincipalInfo*
    ptr_SystemPrincipalInfo()
    {
        return reinterpret_cast<SystemPrincipalInfo*>((&((mValue).VSystemPrincipalInfo)));
    }
    const SystemPrincipalInfo* const
    constptr_SystemPrincipalInfo() const
    {
        return reinterpret_cast<const SystemPrincipalInfo* const>((&((mValue).VSystemPrincipalInfo)));
    }
    NullPrincipalInfo*
    ptr_NullPrincipalInfo()
    {
        return reinterpret_cast<NullPrincipalInfo*>((&((mValue).VNullPrincipalInfo)));
    }
    const NullPrincipalInfo* const
    constptr_NullPrincipalInfo() const
    {
        return reinterpret_cast<const NullPrincipalInfo* const>((&((mValue).VNullPrincipalInfo)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT PrincipalInfo() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT PrincipalInfo(const ContentPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(const SystemPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(const NullPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(const PrincipalInfo& aOther);

    ~PrincipalInfo();

    Type
    type() const
    {
        return mType;
    }

    PrincipalInfo&
    operator=(const ContentPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(const SystemPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(const NullPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(const PrincipalInfo& aRhs);

    bool
    operator==(const ContentPrincipalInfo& aRhs) const;

    bool
    operator==(const SystemPrincipalInfo& aRhs) const;

    bool
    operator==(const NullPrincipalInfo& aRhs) const;

    bool
    operator==(const PrincipalInfo& aRhs) const;

    ContentPrincipalInfo&
    get_ContentPrincipalInfo()
    {
        AssertSanity(TContentPrincipalInfo);
        return (*(ptr_ContentPrincipalInfo()));
    }
    const ContentPrincipalInfo&
    get_ContentPrincipalInfo() const
    {
        AssertSanity(TContentPrincipalInfo);
        return (*(constptr_ContentPrincipalInfo()));
    }
    operator ContentPrincipalInfo&()
    {
        return get_ContentPrincipalInfo();
    }
    operator const ContentPrincipalInfo&() const
    {
        return get_ContentPrincipalInfo();
    }

    SystemPrincipalInfo&
    get_SystemPrincipalInfo()
    {
        AssertSanity(TSystemPrincipalInfo);
        return (*(ptr_SystemPrincipalInfo()));
    }
    const SystemPrincipalInfo&
    get_SystemPrincipalInfo() const
    {
        AssertSanity(TSystemPrincipalInfo);
        return (*(constptr_SystemPrincipalInfo()));
    }
    operator SystemPrincipalInfo&()
    {
        return get_SystemPrincipalInfo();
    }
    operator const SystemPrincipalInfo&() const
    {
        return get_SystemPrincipalInfo();
    }

    NullPrincipalInfo&
    get_NullPrincipalInfo()
    {
        AssertSanity(TNullPrincipalInfo);
        return (*(ptr_NullPrincipalInfo()));
    }
    const NullPrincipalInfo&
    get_NullPrincipalInfo() const
    {
        AssertSanity(TNullPrincipalInfo);
        return (*(constptr_NullPrincipalInfo()));
    }
    operator NullPrincipalInfo&()
    {
        return get_NullPrincipalInfo();
    }
    operator const NullPrincipalInfo&() const
    {
        return get_NullPrincipalInfo();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PBackgroundSharedTypes_h
